#include <hw/pci.h>
#include <hw/pci_devices.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/neutrino.h>
//#include <tsi_mapping.h>
#include <string.h>
//#include <tsi_struct.h>
#include "pci_comms.h"


int main(void) {
    uint8_t error;
    struct register_info *reginfo = TSI148_map_structure(&error);
    if (error) {
        printf("Błąd mapowania rejestrów! Kod: %d\n", error);
        return EXIT_FAILURE;
    }

    write_register(reginfo, &reginfo->OTAT0, 0x00100000);
    uint32_t value = read_register(reginfo, &reginfo->OTAT0);
    printf("OTAT0: 0x%08X\n", value);
    
    set_register_bits(reginfo, &reginfo->OTAT0, 0x00010000);
    clear_register_bits(reginfo, &reginfo->OTAT0, 0x00010000);
    modify_register(reginfo, &reginfo->OTAT0, 0x00F00000, 0x00200000);
    
    return EXIT_SUCCESS;
}

